"use strict";

exports.__esModule = true;
exports.default = render;

// Render by depth-first reference traversal

function render(node) {
  var sourceElementsKey = arguments.length <= 1 || arguments[1] === undefined ? "sourceElements" : arguments[1];
  var path = arguments.length <= 2 || arguments[2] === undefined ? "" : arguments[2];

  if (node == null) throw new Error("Illegal reference at " + path);
  var lists = {};
  if (node[sourceElementsKey] === undefined) throw new Error('"' + sourceElementsKey + '" missing at ' + path);
  return node[sourceElementsKey].map(function (el) {
    if (el.reference) {
      var _el$reference$split = el.reference.split('#');

      var key = _el$reference$split[0];
      var list = _el$reference$split[1];

      if (list === "next") {
        var i = lists[key] || 0;
        lists[key] = i + 1;
        if (el.element) {
          return el.value != null ? el.value : node[el.reference];
        } else {
          return render(node[key][i], sourceElementsKey, path + '.' + key + '[' + i + ']');
        }
      } else {
        if (el.element) {
          return el.value != null ? el.value : node[el.reference];
        } else {
          return render(node[key], sourceElementsKey, path + '.' + key);
        }
      }
    } else if (el.element !== "EOF") {
      return el.value;
    }
  }).join("");
}